unit printdata;

interface
   procedure printout;
   procedure startdemo; // Nf


var
   pxscal,pyscal,pscal: double;

implementation
uses Printers,platespring,Graphics,SysUtils,tawadata,forms,Classes;

procedure startdemo;    // Nf
var
  KK: integer;
begin
  with plate do begin
    BorderStyle := bsNone;
    ClientHeight := 350;
    ClientWidth := 350;
    top := (screen.Height - Height) div 2;
    Left := (screen.Width - Width) div 2;
    clear;
    with Image1.Canvas do begin
      Font.Style := [fsBold];
      Font.Color := clBlack;
      Font.Height := 18;
      LL := 'olvZ';
      dtop := TextWidth(LL);
      dleft := (ClientWidth - dtop) div 2;
      TextOut(dleft, 50,LL);

      Font.Color := clMaroon;
      Font.Height := 16;
      LL := Verdis;
      dtop := TextWidth(LL);
      dleft := (ClientWidth - dtop) div 2;
      TextOut(dleft, 80,LL);

      Font.Color := clPurple;
      Font.Height := 14;
      LL := '{\tg̎gp蔭́A';
      dtop := TextWidth(LL);
      dleft := (ClientWidth - dtop) div 2;
      TextOut(dleft, 250,LL);
      LL := 'gp҂̐ӔĈłA\tg񋟎';
      TextOut(dleft, 264,LL);
      LL := '̐ӔCł͂܂B';
      TextOut(dleft, 278,LL);
      Font.Style := [];
      Pen.Width := 1;
      Pen.Color := clblack;
      Pen.Style := psSolid;
      moveTo(0,0);
      LineTo(0,349);
      LineTo(349,349);
      LineTo(349,0);
      LineTo(0,0);
      LineTo(15,15);
      LineTo(15,334);
      LineTo(334,334);
      LineTo(334,15);
      LineTo(15,15);
      moveTo(349,349);
      LineTo(334,334);
      moveTo(0,349);
      LineTo(15,334);
      moveTo(349,0);
      LineTo(334,15);
      Brush.Style := bsSolid;
      Brush.Color := $00F0F0F0;
      FloodFill(170,7,clblack,fsBorder);
      Brush.Color := $00C0C0C0;
      FloodFill(7,170,clblack,fsBorder);
      Brush.Color := $00808080;
      FloodFill(342,170,clblack,fsBorder);
      Brush.Color := $00404040;
      FloodFill(170,342,clblack,fsBorder);
      Brush.Color := clMaroon;
      FillRect(Rect(35,150,40,200));
      Pen.Color := clblue;
      dtop := 177;
      moveTo(40,dtop);
      dtop := 173;
      LineTo(40,dtop);
      Miss := 8;
      for KK := 0 to Miss do
        begin
          dtop := dtop + KK;
          dleft := 70 + KK * 30;
          LineTo(dleft, dtop);
        end;
      dtop := 177;
      moveTo(40,dtop);
      for KK := 0 to Miss do
        begin
          dtop := dtop + KK;
          dleft := 70 +  KK * 30;
          LineTo(dleft, dtop);
        end;
      LineTo(dleft, dtop - 4);
      Brush.Color := clFuchsia;
      FloodFill(42,175,clblue,fsBorder);
      Brush.Color := clGreen;
      Ellipse(260, 160, 300, 200);
    end;
    Timer1.Enabled := true;
  end;
end;

procedure PYA(xpos,ypos:integer; Q: double);  // ̍
var
  YAQ,QYAS,QYAE: Double;
  LENGYAS,LENGYAE,OFFYAS,OFFYAE: integer;
begin
  YAQ:= PI/12;
  QYAS := Q + YAQ;
  QYAE := Q - YAQ;
  if QYAS > PI * 2 then QYAS := QYAS - PI * 2;
  if QYAE > PI * 2 then QYAE := QYAE - PI * 2;
  if QYAS < 0 then QYAS := QYAS + PI * 2;
  if QYAE < 0 then QYAE := QYAE + PI * 2;
  LENGYAS := round(COS(QYAS) * 10 * pscal);
  LENGYAE := round(COS(QYAE) * 10 * pscal);
  OFFYAS := round(SIN(QYAS) * 10 * pscal);
  OFFYAE := round(SIN(QYAE) * 10 * pscal);
  with Printer.Canvas do begin
    MoveTo(xpos,ypos);
    Lineto(xpos + LENGYAS,ypos + OFFYAS);
    MoveTo(xpos,ypos);
    Lineto(xpos + LENGYAE,ypos + OFFYAE);
  end;
end;

procedure printout;                           // v^[ւ̏o
var
  ixpos,pxpos,pypos,pich,gpos:integer;
  LLeng,KK: integer;
begin
  if plate.PrintDialog1.Execute then else exit;

  with Printer do
    begin
      BeginDoc;
      pxscal := PageWidth / plate.ClientWidth;
      pyscal := PageHeight /(plate.ClientHeight + 150);
      if pxscal < pyscal then pscal := pxscal
                         else pscal := pyscal;
      ixpos := round(60 * pscal);
      pxpos := round(160 * pscal);
      with Canvas do begin
        Brush.Color := clWhite;
        Brush.Style := bsSolid;
        Font.Name := 'lr ';
        Font.Style := [];
        Font.Height := round(17 * pscal);

        Font.Color := clBlue;
        TextOut(round(50 * pscal),round(20 * pscal),'ЎolvZ');
        Font.Color := clBlack;
        Font.Height := round(15 * pscal);
        pypos := round(40 * pscal);
        pich :=  round(17 * pscal);
        TextOut(ixpos,pypos,'ށ@');
        TextOut(pxpos,pypos,matname[MatNo]);
        LLeng := pxpos + round(20 * pscal) + TextWidth(matname[MatNo]);
        TextOut(LLeng,pypos,'ceW ' + floatTostr(Eng[MatNo]) + ' m/mm');
        LLeng := LLeng + TextWidth('ceW ' + floatTostr(Eng[MatNo]) + ' m/mm');
        Font.Height := round(12 * pscal);
        TextOut(LLeng,pypos,'2');
        Font.Height := round(15 * pscal);
        pypos := pypos + pich;
        Font.Color := clBlack;
        TextOut(ixpos,pypos,'@@@@@@' + floatTostr(hin) + ' mm');
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'ol@@' + floatTostr(Bin) + ' mm');
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'ol[@@' + floatTostr(B1in) + ' mm');
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'[̒@@' + floatTostr(Lin) + ' mm');
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'׏d_̒@' + floatTostr(L1in) + ' mm');
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'׏d@@@@@@' + floatTostr(Pin) + ' N');
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'݌vZwʒu@' + floatTostr(Xin) + ' mm');
        // vZʈ
        Font.Style := [fsBold];
        Font.Color := clBlue;
        pypos := pypos + pich;
        TextOut(ixpos - round(10 * pscal),pypos,'vZ');
        Font.Color := clBlack;
        Font.Style := [];
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'ő剞́@@@@' + floatTostrF(s,ffFixed,10,3));
        LLeng := TextWidth('ő剞́@@@@' + floatTostrF(s,ffFixed,10,3));
        Font.Color := clBlue;
        TextOut(ixpos + LLeng,pypos,' N/mm');
        LLeng := LLeng + TextWidth(' N/mm');
        Font.Height := round(12 * pscal);
        TextOut(ixpos + LLeng,pypos - round(2 * pscal),'2');
        Font.Height := round(15 * pscal);
        Font.Color := clBlack;
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'é@@@@');
        LLeng := ixpos + TextWidth('é@@@@');
        TextOut(LLeng,pypos,floatTostrF(stsmax,ffFixed,10,3));
        LLeng := LLeng + TextWidth(floatTostrF(stsmax,ffFixed,10,3));
        Font.Color := clBlue;
        TextOut(LLeng,pypos,' N/mm');
        LLeng := LLeng + TextWidth(' N/mm');
        Font.Height := round(12 * pscal);
        TextOut(LLeng,pypos - round(2 * pscal),'2');
        LLeng := LLeng + TextWidth('2');
        Font.Color := clred;
        Font.Height := round(15 * pscal);
        LLeng := LLeng + TextWidth('@@@');
        if MatNo <> 5 then TextOut(LLeng,pypos,'imȃf[^[ׁAQllłj');
        Font.Color := clBlack;
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'wʒú@@' + floatTostrF(sx,ffFixed,10,3));
        Font.Color := clBlue;
        LLeng := TextWidth('wʒú@@' + floatTostrF(sx,ffFixed,10,3));
        TextOut(ixpos + LLeng,pypos,' N/mm');
        LLeng := LLeng + TextWidth(' N/mm');
        Font.Height := round(12 * pscal);
        TextOut(ixpos + LLeng,pypos - round(2 * pscal),'2');
        Font.Height := round(15 * pscal);
        Font.Color := clBlack;
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'wʒuXgC@@@');
        LLeng := ixpos + TextWidth('wʒuXgC@@@');
        TextOut(LLeng,pypos,floatTostrF(sx / E * 1000000,ffFixed,10,3));
        LLeng := LLeng + TextWidth(floatTostrF(sx / E * 1000000,ffFixed,10,3));
        Font.Color := clBlue;
        TextOut(LLeng,pypos,'strain(ϲ۽ڲ)');

        Pen.Width := round(2 * pscal);
        MoveTo(ixpos,pypos);
        gpos := pypos + round(270 * pscal);
        MoveTo(round(50 * pscal), gpos);
        xpos := 0;
        zxback := 0;
        for KK := 1 to calck do
          begin
            X := Lpich * KK;
            if Bin > B1in then
              begin
                B1 :=Bin - (Bin - B1in) / Lin * X;
                L1 := X;
                P := Pin  * L1in / X + Pin * (L1in - X) / X / phk;
              end;
            plate.calc;   // vZ
            xpos := xpos + sqrt(Lpich * Lpich - (z - zxback) * (z - zxback));
            zxback := z;
            LineTo(round((50 + xpos * xkeisu) * pscal), gpos + round(z * ykeisu * pscal));
            if Bin > b1in then
              begin
                if KK = calck - 1 then zback := z;
                if KK = calck then
                  begin
                    zout := z + (z - zback) / Lpich * (Lin - L1in);
                    xpos := xpos + sqrt((Lin - L1in) * (Lin - L1in) - (z - zout) * (z - zout));
                    LineTo(round((50 + Xpos * xkeisu) * pscal), gpos + round(zout * ykeisu * pscal));
                    zxback := zout;
                    if Xin <= L1in then
                      begin
                        B1 := Bin - (Bin - B1in) / Lin * Xin; // Xin̕vZ
                        L1 := Xin;                            // Xin׏d_ɂBc̉׏d͉ł
                        X :=  Xin;
                        if X = 0 then P := 0
                                 else P := Pin  * L1in / X + Pin * (L1in - X) / X / phk;
                        plate.calc;     // vZ
                        zout := z;
                      end
                      else zout := z + (z - zback) / Lpich * (Xin - L1in);  // ׏d_𒴂Ăꍇ@ω萄
                  end;
              end
              else
              begin
                X := Xin;
                L1 := L1in;
                P := Pin;
                plate.calc;             // vZ
                zout := z;
              end;
          end;
        Pen.Width := 1;
        MoveTo(round((50 + Xpos * xkeisu + 5) * pscal),gpos + round(zsout * ykeisu * pscal));
        LineTo(round((50 + 450) * pscal) ,gpos + round(zsout * ykeisu * pscal));
        MoveTo(round((50 + Lin * xkeisu + 5) * pscal), gpos);
        LineTo(round((50 + 450) * pscal), gpos);
        if round(zsout * ykeisu) < 20 then
          begin
            MoveTo(round((50 + 445) * pscal), gpos + round((zsout * ykeisu + 15) * pscal));
            LineTo(round((50 + 445) * pscal), gpos - round(15 * pscal));
            PYa(round((50 + 445) * pscal), gpos + round(zsout * ykeisu * pscal),pi / 2);
            PYa(round((50 + 445) * pscal), gpos,pi + pi / 2);
          end
          else
          begin
            MoveTo(round((50 + 445) * pscal), gpos + round(zsout * ykeisu * pscal));
            LineTo(round((50 + 445) * pscal), gpos);
            PYa(round((50 + 445) * pscal), gpos + round(zsout * ykeisu * pscal),pi + pi / 2);
            PYa(round((50 + 445) * pscal), gpos, pi / 2);
          end;
        TextOut(round((50 + 450) * pscal), gpos + round((zsout * ykeisu / 2  - 7) * pscal)
                                                           ,floatTostrF(zsout,ffFixed,10,3));
        // ׏d_݌vZ
        X := L1in;
        L1 := L1in;
        P := Pin;
        if Bin > B1in then B1 := Bin - (Bin - B1in) / Lin * L1in
                      else B1 := B1in;
        plate.calc;// vZ
        zpout := z;
        Pen.Width := 1;
        MoveTo(round(50 * pscal), gpos - round(5 * pscal));
        LineTo(round(50 * pscal), gpos - round(100 * pscal));
        MoveTo(round(50 * pscal), gpos);
        LineTo(round((50 + Lin * xkeisu) * pscal), gpos);
        font.Height := round(16 * pscal);
        if Xin < L1in then
          begin
            MoveTo(round((50 + xin * xkeisu) * pscal), gpos - round(5 * pscal));
            LineTo(round((50 + Xin * xkeisu) * pscal), gpos - round(40 * pscal));
            MoveTo(round(50 * pscal),gpos - round(35 * pscal));
            LineTo(round((50 + Xin * xkeisu) * pscal), gpos - round(35 * pscal));
            PYa(round(50 * pscal), gpos - round(35 * pscal),0);
            PYa(round((50 + Xin * xkeisu) * pscal), gpos - round(35 * pscal),pi);
            LL := 'vZwʒu';
            inleng := TextWidth(LL);
            dleft := round(50 * pscal) + (round(xin * xkeisu * pscal) - inleng) div 2;
            font.Color := clFuchsia;
            TextOut(dleft,gpos - round((35 + 17) * pscal),LL);
            MoveTo(round((50 + L1in * xkeisu) * pscal),gpos - round(5 * pscal));
            LineTo(round((50 + L1in * xkeisu) * pscal),gpos - round(70 * pscal));
            MoveTo(round(50 * pscal), gpos - round(65 * pscal));
            LineTo(round((50 + L1in * xkeisu) * pscal),gpos - round(65 * pscal));
            PYa(round(50 * pscal),gpos - round(65 * pscal),0);
            PYa(round((50 + L1in * xkeisu) * pscal),gpos - round(65 * pscal),pi);
            LL := '׏dʒu';
            inleng := TextWidth(LL);
            dleft := round(50 * pscal) + (round(L1in * xkeisu * pscal) - inleng) div 2;
            font.Color := clFuchsia;
            TextOut(dleft,gpos - round((65 + 17) * pscal),LL)
          end
          else
          begin
            MoveTo(round((50 + L1in * xkeisu) * pscal),gpos - round(5 * pscal));
            LineTo(round((50 + L1in * xkeisu) * pscal),gpos - round(40 * pscal));
            MoveTo(round(50 * pscal),gpos - round(35 * pscal));
            LineTo(round((50 + L1in * xkeisu) * pscal),gpos - round(35 * pscal));
            PYa(round(50 * pscal),gpos - round(35 * pscal),0);
            PYa(round((50 + L1in * xkeisu) * pscal),gpos - round(35 * pscal),pi);
            LL := '׏dʒu';
            inleng := TextWidth(LL);
            dleft := round(50 * pscal) + (round(L1in * xkeisu * pscal) - inleng) div 2;
            font.Color := clFuchsia;
            TextOut(dleft,gpos - round((35 + 17) * pscal),LL);
            MoveTo(round((50 + Xin * xkeisu) * pscal),gpos - round(5 * pscal));
            LineTo(round((50 + Xin * xkeisu) * pscal),gpos - round(70 * pscal));
            MoveTo(round(50  * pscal),gpos - round(65 * pscal));
            LineTo(round((50 + Xin * xkeisu) * pscal),gpos - round(65 * pscal));
            PYa(round(50 * pscal),gpos - round(65 * pscal),0);
            PYa(round((50 + Xin * xkeisu) * pscal),gpos - round(65 * pscal),pi);
            LL := 'vZwʒu';
            inleng := Canvas.TextWidth(LL);
            dleft := round(50 * pscal) + (round(xin * xkeisu * pscal) - inleng) div 2;
            font.Color := clFuchsia;
            TextOut(dleft,gpos - round((65 + 17) * pscal),LL);
          end;
        MoveTo(round((50 + Lin * xkeisu) * pscal),gpos - round(5 * pscal));
        LineTo(round((50 + Lin * xkeisu) * pscal),gpos - round(100 * pscal));
        MoveTo(round(50 * pscal),gpos - round(95 * pscal));
        LineTo(round((50 + Lin * xkeisu) * pscal), gpos - round(95 * pscal));
        PYa(round(50 * pscal),gpos - round(95 * pscal),0);
        PYa(round((50 + Lin * xkeisu) * pscal),gpos - round(95 * pscal),pi);
        LL := floatTostrF(Lin,ffGeneral,10,3) + ' mm';
        inleng := TextWidth(LL);
        dleft := round(50 * pscal) + (round(Lin * xkeisu * pscal) - inleng) div 2;
        font.Height := round(16 * pscal);
        font.Color := clFuchsia;
        TextOut(dleft,gpos - round((95 + 17)* pscal),LL);
        Font.Style := [];
        Font.Color := clBlack;
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'wʒuݗʁ@');
        inleng := ixpos + TextWidth('wʒuݗʁ@');
        LL := floatTostrF(zout,ffFixed,10,3);
        TextOut(inleng,pypos,LL);
        inleng := inleng + TextWidth(LL);
        Font.Color := clBlue;
        TextOut(inleng,pypos,' mm');
        Font.Color := clBlack;
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'[ݗʁ@@@');
        inleng := ixpos + TextWidth('[ݗʁ@@@');
        LL := floatTostrF(zsout,ffFixed,10,3);
        TextOut(inleng,pypos,LL);
        inleng := inleng + TextWidth(LL);
        Font.Color := clBlue;
        TextOut(inleng,pypos,' mm');
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'׏dʒuݗʁ@@');
        inleng := ixpos + TextWidth('׏dʒuݗʁ@@');
        LL := floatTostrF(zpout,ffFixed,10,3);
        TextOut(inleng,pypos,LL);
        inleng := inleng + TextWidth(LL);
        Font.Color := clBlue;
        TextOut(inleng,pypos,' mm ');
        inleng := inleng + TextWidth(' mm ');
        if zpout/L1in > 0.2 then
          begin
            Font.Color := clRed;
            TextOut(inleng,pypos,'݂傫');
          end;
        pypos := pypos + pich;
        Font.Color := clBlack;
        TextOut(ixpos,pypos,'坚݌W @' + floatTostrF(phi,ffFixed,10,6));
        pypos := pypos + pich;
        TextOut(ixpos,pypos,'͏CW ' + floatTostrF(ramudaMax,ffFixed,10,6));
      end;
    EndDoc;
  end;
end;

end.

