unit platespring;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  Tplate = class(TForm)
    Timer1: TTimer;
    PrintDialog1: TPrintDialog;
    Image1: TImage;
    returnbtn: TBitBtn;
    typeret: TBitBtn;
    OKBtn: TButton;
    fatigue: TBitBtn;
    strength: TBitBtn;
    printbtn: TBitBtn;
    bend: TButton;
    loading: TBitBtn;
    bending: TBitBtn;
    Button2: TButton;
    Button1: TButton;
    come: TBitBtn;
    calcbtn: TBitBtn;
    tawabtn: TButton;
    Load: TButton;
    loadp: TButton;
    lengsen: TButton;
    Swidth: TButton;
    Bwidth: TButton;
    thickness: TButton;
    material: TButton;
    datain: TEdit;
    Datainb: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure materialClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure DatainKeyPress(Sender: TObject; var Key: Char);
    procedure thicknessClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BwidthClick(Sender: TObject);
    procedure SwidthClick(Sender: TObject);
    procedure lengsenClick(Sender: TObject);
    procedure loadpClick(Sender: TObject);
    procedure LoadClick(Sender: TObject);
    procedure calcbtnClick(Sender: TObject);
    procedure returnbtnClick(Sender: TObject);
    procedure tawabtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure printbtnClick(Sender: TObject);
    procedure fatigueClick(Sender: TObject);
    procedure bendingClick(Sender: TObject);
    procedure loadingClick(Sender: TObject);
    procedure typeretClick(Sender: TObject);
    procedure bendClick(Sender: TObject);
    procedure strengthClick(Sender: TObject);
    procedure DatainbKeyPress(Sender: TObject; var Key: Char);
    procedure comeClick(Sender: TObject);
  private
    { Private 錾 }
    procedure ButtonOn;
    procedure matinput;         {ގԍ͏}
    procedure inputeng;         // Oe͓
    procedure enginput;         // Oe͓͏
    procedure thicknessd;       // ͕\
    procedure thicknessinput;   // ͏
    procedure Bindisp;          // ol͕\
    procedure Bininput;         // ol͏
    procedure B1indisp;         // ol[͕\
    procedure B1ininput;        // ol[͏
    procedure Lindisp;          // ol[͕̒\
    procedure Lininput;         // ol[̒͏
    procedure L1indisp;         // ׏d_͕̒\
    procedure L1ininput;        // ׏d_̒͏
    procedure Pindisp;          // ׏d͕\
    procedure Pininput;         // ׏d͏
    procedure tawamidisp;       // ݈ʒu͕\
    procedure tawaminput;       // ݈ʒu͏
  public
    { Public 錾 }
    procedure Buttonoff;
    procedure calc;             // vZ
    procedure CLEAR;
    procedure CtextOut;         // vZ
    procedure Inputdata;        {͑I}
    procedure YA(xpos,ypos:integer; Q: double); // }
    procedure calcin;           // vZJn
  end;

var
  plate: Tplate;
  P:     double;  // ׏d
  Pin:   double;  // ׏d͒l
  L1:    double;  // ׏d_
  L1in:  double;  // ׏d_͒l
  X:     double;  // Cӝ݈ʒu
  Xin:   double;  // Cӝ݈ʒu͒l
  L:     double;  // ol
  Lin:   double;  // ol͒l
  B:     double;  // ol
  Bin:   double;  // ol͒l
  B1:    double;  // ol[
  B1in:  double;  // ol[͒l
  h:     double;  // 
  hin:   double;  // ͒l
  E:     double;  // ceW
  zin:   double;  // ݓ͒l
  z:     double;  // 
  zcin:  double;  // ݌vZp
  zout:  double;  // out
  zsout: double;  // [ݗ
  zpout: double;  // ׏d_ݗ
  s:     double;  // ő剞
  sx:    double;  // wʒu
  M:     double;  // B1/B
  Bm :   double;  // Ȃ
  Kn:    double;  // `W
  MatNo:  byte;   // Iގԍ
  Dataf:  byte;   // DATA̓tO
  Focusd: byte;   // datatO
  graff:  byte;   // 坚ݕ\tO
  ep:     double; // XgC
  xkeisu,Lpich,ykeisu,zxback: double; // OtBbNW
  timerf: byte;   // P N@O@
  typef:  byte;   //  1 ׏dwvZ@Q@ݎwvZ
  dp:     double; // ׏dl
  ptina,ptinb: double;  // ׏dwvZp͒l
  ttina,ttinb: double;  // ݎwvZp͒l
  stmax,stmin: double;  // gp͈͘c݉
  stsmax:      double;  // e͐l
  comf: byte;

// Tu[`ŎRgp
  LL:    string;
  inleng: integer;
  chchar: char;
  dleft,dtop: integer;
  suisen: byte;
  Miss: integer;
  zback :double;
  Xpos  :double;
  Eng: array[1..5] of double =(206000,196000,186000, 96040,     0); // eW
  str: array[1..5] of double =( 833.6, 735, 617.4, 411.9,     0);   // N^Q
//
const
     matname: array[1..5] of string =('olS|','olpڽ|(SUS631)'
                 ,'olpڽ|(SUS301)','olpӐ','ގ');
     zaiNo = 5;       // ޗ
     bpich = 30;      // {^\߯
     thick: array[1..30] of double =
                   (0.05, 0.06, 0.08, 0.10, 0.12, 0.15, 0.18, 0.20, 0.25, 0.30,
                    0.35, 0.40, 0.45, 0.50, 0.55, 0.60, 0.70, 0.80, 0.90, 1.00,
                    1.10, 1.20, 1.40, 1.50, 1.60, 1.80, 2.00, 2.30, 2.50, 2.60);
     //              0 -  1 Z   2   3  4 
     thickSpc: array[1..30] of byte =
                 (   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
                     0,   1,   0,   3,   0,   3,   1,   3,   1,   3,
                     0,   3,   2,   2,   3,   2,   3,   2,   2,   2);
     thickstn: array[1..30] of byte =
                 (   0,   0,   0,   3,   1,   1,   0,   3,   1,   3,
                     1,   1,   1,   1,   1,   1,   1,   1,   2,   2,
                     2,   2,   2,   0,   2,   0,   0,   0,   0,   0);
     thickcup: array[1..30] of byte =
                 (   4,   4,   4,   3,   1,   3,   1,   3,   3,   3,
                     1,   1,   2,   1,   0,   1,   1,   1,   4,   1,
                     0,   2,   2,   2,   2,   2,   2,   0,   0,   0);
     Verdis = 'olvZ@Ver 2.0  Makoic.inc';
     phk = 2.1;       // `vZ␳W
     calck = 50;      // ݌vZ
     yposk = 117;
     yposbtn = 115;

implementation

uses tawadata,printdata;

{$R *.DFM}

procedure Tplate.CLEAR;
var
   NewRectL: TRect;
   Bitmap: Tbitmap;
begin
  Image1.Picture.Graphic := nil;
  Bitmap := TBitmap.Create;
  Bitmap.Width := ClientWidth;
  Bitmap.height:= ClientHeight;
  Image1.Picture.Graphic := Bitmap;
  Bitmap.Free;
  Image1.Canvas.Brush.Color := clWhite;
  NewRectL := Rect(0, 0, ClientWidth, ClientHeight);
  Image1.Canvas.FillRect(NewRectL);
end;

procedure Tplate.YA(xpos,ypos:integer; Q: double);
var
  YAQ,QYAS,QYAE: Double;
  LENGYAS,LENGYAE,OFFYAS,OFFYAE: integer;
begin
  YAQ:= PI/12;
  QYAS := Q + YAQ;
  QYAE := Q - YAQ;
  if QYAS > PI * 2 then QYAS := QYAS - PI * 2;
  if QYAE > PI * 2 then QYAE := QYAE - PI * 2;
  if QYAS < 0 then QYAS := QYAS + PI * 2;
  if QYAE < 0 then QYAE := QYAE + PI * 2;
  LENGYAS := round(COS(QYAS) * 10);
  LENGYAE := round(COS(QYAE) * 10);
  OFFYAS := round(SIN(QYAS) * 10);
  OFFYAE := round(SIN(QYAE) * 10);
  Image1.Canvas.MoveTo(xpos,ypos);
  Image1.Canvas.Lineto(xpos + LENGYAS,ypos + OFFYAS);
  Image1.Canvas.MoveTo(xpos,ypos);
  Image1.Canvas.Lineto(xpos + LENGYAE,ypos + OFFYAE);
end;

procedure Tplate.tawaminput;  // ݈ʒu͏
var
  IIL: integer;
begin
  Miss := 0;
  LL := Datain.text;
  inleng := length(LL);
  if inleng = 0 then exit;
  for IIL := 1 to inleng do
    begin
      chchar := LL[IIL];
      case chchar of
        '0'..'9':;
             '.':inc(Miss);
              #0:break;
            else exit;
      end;
    end;
  if Miss > 1 then exit;
  Xin := strTofloat(LL);
  if (Xin < 0) or (Xin > Lin) then
  begin
    Image1.Canvas.Font.Color := clBlack;
    Image1.Canvas.TextOut(30,310,'݌vZʒuAol͈̒͊OłB');
    exit;
  end;
  Dataf := 0;
  Inputdata;          {͑I}
end;

procedure Tplate.tawamidisp;  // ݈ʒu͕\
var
  II: integer;
const
  Pic3 = 200;
  Pleft = 150;
begin
  ClientHeight := 368;
  ClientWidth := 632;
  clear;
  Dataf := 9;
  Buttonoff;
  with Image1.Canvas do begin
    Font.Name := 'lr ';
    Font.Height := 18;
    Font.Color := clRed;
    Font.Style := [fsBold];
    TextOut(10,5,'݌vZʒu̓');
    Font.Height := 17;
    Font.Color := clFuchsia;
    Font.Style := [];
    pen.Color := clBlack;
    pen.Style := psSolid;
    pen.Width := 2;

    MoveTo(50 + Pleft,0 + Pic3);
    LineTo(250 + Pleft,0 + Pic3);
    LineTo(250 + Pleft,5 + Pic3);
    LineTo(50 + Pleft,5 + Pic3);
    MoveTo(50 + Pleft,-12 + Pic3);
    LineTo(50 + Pleft,17 + Pic3);
    pen.Width := 1;
    for II := 0 to 5 do
      begin
        MoveTo(50 + Pleft,-12 + Pic3 + 5 * II);
        LineTo(30 + Pleft,-5 + Pic3 + 5 * II);
      end;

    Ellipse(230 + Pleft - 3, Pic3 -3,230 + Pleft + 3, Pic3 + 3);
    Brush.Style := bsSolid;
    Brush.Color := clRed;
    FloodFill(230 + Pleft,Pic3,clBlack,fsBorder);

    MoveTo(50 + Pleft,-40 + Pic3);
    LineTo(50 + Pleft,-25 + Pic3);
    MoveTo(230 + Pleft,-60 + Pic3);
    LineTo(230 + Pleft,-5 + Pic3);

    MoveTo(50 + Pleft,-35 + Pic3);
    LineTo(230 + Pleft,-35 + Pic3);
    YA(50 + Pleft,-35 + Pic3, 0);
    YA(230 + Pleft,-35 + Pic3,pi);
    YA(230 + Pleft,-5 + Pic3,pi + pi / 2);
    Brush.Style := bsClear;
    Font.Color := clFuchsia;
    TextOut(100,240,'ol̒' + floatTostr(Lin) + ' mm');

    Brush.Color := clWhite;
    LL := 'vZʒu̒';
    dleft := TextWidth(LL);
    dtop := (230 - 50 - dleft) div 2;
    TextOut(50 + Pleft + dtop,-45 + Pic3,LL);
    LL := '݌vZʒu';
    dleft := TextWidth(LL) div 2;
    Font.Color := clRed;
    Font.Style := [fsBold];
    TextOut(230 + Pleft - dleft,-80 + Pic3,LL);
    Font.Color := clBlack;
    Font.Style := [];
    TextOut(50, 80,'׏d_Ƃ͈ႤARȈʒȗ̝݂傫߂鎖');
    TextOut(50,100,'o܂B');
    Font.Color := clBlue;
    TextOut(100, 331,'݌vZʒu̒@mm');
    Datain.Font.Height := 16;
    Datain.top := 330;
    Datain.width := 70;
    Datain.Left := 400;
    OKBtn.Top := 330;
    OKBtn.Left := 480;
    OKBtn.Visible := True;
    Datain.Visible := True;
    if Xin < 0 then Datain.Text := ''
               else Datain.Text := floatTostr(Xin);
    Datain.SetFocus;
  end;
end;

procedure Tplate.Pininput;  // ׏d͏
var
  IIL: integer;
begin
  Miss := 0;
  LL := Datain.text;
  inleng := length(LL);
  if inleng = 0 then exit;
  for IIL := 1 to inleng do
    begin
      chchar := LL[IIL];
      case chchar of
        '0'..'9':;
             '.':inc(Miss);
              #0:break;
            else exit;
      end;
    end;
  if Miss > 1 then exit;
  Pin := strTofloat(LL);
  if Pin < 0 then exit;
  Dataf := 0;
  Inputdata;              {͑I}
end;

procedure Tplate.Pindisp; // ׏d͕\
var
  II: integer;
const
  Pic3 = 200;
  Pleft = 150;
begin
  ClientHeight := 390;
  ClientWidth := 632;
  clear;
  Dataf := 8;
  Buttonoff;
  with Image1.Canvas do begin
    Font.Name := 'lr ';
    Font.Height := 18;
    Font.Color := clRed;
    Font.Style := [fsBold];
    TextOut(10,5,'׏d̓');
    Font.Height := 17;
    Font.Style := [];
    Font.Color := clBlack;
    TextOut(50,80,'׏d_ɂ׏d̒l͂܂B');
    Font.Color := clFuchsia;
    pen.Color := clBlack;
    pen.Style := psSolid;
    pen.Width := 2;

    MoveTo(50 + Pleft,0 + Pic3);
    LineTo(250 + Pleft,0 + Pic3);
    LineTo(250 + Pleft,5 + Pic3);
    LineTo(50 + Pleft,5 + Pic3);
    MoveTo(50 + Pleft,-12 + Pic3);
    LineTo(50 + Pleft,17 + Pic3);
    pen.Width := 1;
    for II := 0 to 5 do
      begin
        MoveTo(50 + Pleft,-12 + Pic3 + 5 * II);
        LineTo(30 + Pleft,-5 + Pic3 + 5 * II);
      end;

    Ellipse(230 + Pleft - 3, Pic3 -3,230 + Pleft + 3, Pic3 + 3);
    Brush.Style := bsSolid;
    Brush.Color := clRed;
    FloodFill(230 + Pleft,Pic3,clBlack,fsBorder);

    MoveTo(50 + Pleft,-40 + Pic3);
    LineTo(50 + Pleft,-25 + Pic3);
    MoveTo(230 + Pleft,-60 + Pic3);
    LineTo(230 + Pleft,-5 + Pic3);

    MoveTo(50 + Pleft,-35 + Pic3);
    LineTo(230 + Pleft,-35 + Pic3);
    YA(50 + Pleft,-35 + Pic3, 0);
    YA(230 + Pleft,-35 + Pic3,pi);
    YA(230 + Pleft,-5 + Pic3,pi + pi / 2);

    Brush.Color := clWhite;

    if L1in >0 then LL := floatTostr(L1in) + ' mm'
               else LL := '׏d_̒';
    dleft := TextWidth(LL);
    dtop := (230 - 50 - dleft) div 2;
    TextOut(50 + Pleft + dtop,-45 + Pic3,LL);
    LL := '׏d';
    dleft := TextWidth(LL) div 2;
    Font.Color := clRed;
    Font.Style := [fsBold];
    TextOut(230 + Pleft - dleft,-80 + Pic3,LL);
    Font.Color := clBlue;
    Font.Style := [];
    TextOut(100, 331,'׏d̒Pʂ́Am(ƭ)');
    Font.Height := 15;
    Font.Color := clGreen;
    TextOut(230,360,'dŕύXɖ߂܂B');
    Datain.Font.Height := 16;
    Datain.top := 330;
    Datain.width := 70;
    Datain.Left := 400;
    OKBtn.Top := 330;
    OKBtn.Left := 480;
    OKBtn.Visible := True;
    Datain.Visible := True;
    if Pin < 0 then Datain.Text := ''
               else Datain.Text := floatTostr(Pin);
    Datain.SetFocus;
  end;
end;

procedure Tplate.L1ininput; // ׏d_̒͏
var
  IIL: integer;
begin
  Miss := 0;
  LL := Datain.text;
  inleng := length(LL);
  if inleng = 0 then exit;
  for IIL := 1 to inleng do
    begin
      chchar := LL[IIL];
      case chchar of
        '0'..'9':;
             '.':inc(Miss);
              #0:break;
            else exit;
      end;
    end;
  if Miss > 1 then exit;
  L1in := strTofloat(LL);
  if L1in < 0 then exit;
  if L1in > Lin then Lin := L1in;
  Dataf := 0;
  Inputdata;              {͑I}
end;

procedure Tplate.L1indisp;  // ׏d_͕̒\
var
  II: integer;
const
  Pic1 = 95;
  Pic2 = 195;
  Pic3 = 325;
  Pleft = 50;
begin
  ClientHeight := 390;
  ClientWidth := 632;
  clear;
  Dataf := 7;
  Buttonoff;
  with Image1.Canvas do begin
    Font.Name := 'lr ';
    Font.Height := 18;
    Font.Color := clRed;
    Font.Style := [fsBold];
    TextOut(10,5,'׏d_̒');
    Font.Height := 17;
    Font.Color := clFuchsia;
    Font.Style := [];
    pen.Color := clBlack;
    pen.Style := psSolid;
    pen.Width := 2;

    MoveTo(50 + Pleft,0 + Pic1);
    LineTo(250 + Pleft,0 + Pic1);
    LineTo(250 + Pleft,70 + Pic1);
    LineTo(50 + Pleft,70 + Pic1);
    LineTo(50 + Pleft,0 + Pic1);

    MoveTo(50 + Pleft, 0 + Pic2);
    LineTo(250 + Pleft,20 + Pic2);
    LineTo(250 + Pleft,70 + Pic2);
    LineTo(50 + Pleft,90 + Pic2);
    LineTo(50 + Pleft,0 + Pic2);

    MoveTo(50 + Pleft,0 + Pic3);
    LineTo(250 + Pleft,0 + Pic3);
    LineTo(250 + Pleft,5 + Pic3);
    LineTo(50 + Pleft,5 + Pic3);
    MoveTo(50 + Pleft,-12 + Pic3);
    LineTo(50 + Pleft,17 + Pic3);
    pen.Width := 1;
    for II := 0 to 5 do
      begin
        MoveTo(50 + Pleft,-12 + Pic3 + 5 * II);
        LineTo(30 + Pleft,-5 + Pic3 + 5 * II);
      end;

    MoveTo(50 + Pleft,-40 + Pic1);
    LineTo(50 + Pleft,-5 + Pic1);
    MoveTo(230 + Pleft,-40 + Pic1);
    LineTo(230 + Pleft,30 + Pic1);
    MoveTo(230 + Pleft,40 + Pic1);
    LineTo(230 + Pleft,40 + Pic2);
    MoveTo(230 + Pleft,50 + Pic2);
    LineTo(230 + Pleft,-5 + Pic3);
    Ellipse(230 + Pleft - 3, 35 + Pic1 -3,230 + Pleft + 3, 35 + Pic1 + 3);
    Ellipse(230 + Pleft - 3, 45 + Pic2 -3,230 + Pleft + 3, 45 + Pic2 + 3);
    Ellipse(230 + Pleft - 3, Pic3 -3,230 + Pleft + 3, Pic3 + 3);
    Brush.Style := bsSolid;
    Brush.Color := clRed;
    FloodFill(230 + Pleft,35 + Pic1,clBlack,fsBorder);
    FloodFill(230 + Pleft,45 + Pic2,clBlack,fsBorder);
    FloodFill(230 + Pleft,Pic3,clBlack,fsBorder);

    MoveTo(50 + Pleft,-35 + Pic1);
    LineTo(230 + Pleft,-35 + Pic1);
    YA(50 + Pleft,-35 + Pic1, 0);
    YA(230 + Pleft,-35 + Pic1,pi);
    Brush.Color := clWhite;
    dleft := TextWidth('׏d_̒');
    dtop := (230 - 50 - dleft) div 2;
    TextOut(50 + Pleft + dtop,-45 + Pic1,'׏d_̒');
    Font.Color := clBlue;
    TextOut(350,190,'[̒@');
    inleng := 350 + TextWidth('[̒@');
    TextOut(inleng,190,floatTostr(Lin) + 'mm');
    TextOut(330,220,'׏d_̒A[̒z');
    TextOut(330,240,'ꍇ́A[̋AI');
    TextOut(330,260,'ɉ׏d_̒ƁAlɏC');
    TextOut(330,280,'܂B');

    Font.Height := 15;
    Font.Color := clGreen;
    TextOut(230,360,'dŕύXɖ߂܂B');
    Font.Color := clBlue;
    TextOut(320,331,'Pʂmm');

    Datain.Font.Height := 16;
    Datain.top := 330;
    Datain.width := 70;
    Datain.Left := 400;
    OKBtn.Top := 330;
    OKBtn.Left := 480;
    OKBtn.Visible := True;
    Datain.Visible := True;
    if L1in = 0 then Datain.Text := ''
                else Datain.Text := floatTostr(L1in);
    Datain.SetFocus;
  end;
end;

procedure Tplate.Lininput;  // ol[̒͏
var
  IIL: integer;
begin
  Miss := 0;
  LL := Datain.text;
  inleng := length(LL);
  if inleng = 0 then exit;
  for IIL := 1 to inleng do
    begin
      chchar := LL[IIL];
      case chchar of
          '0'..'9':;
               '.':inc(Miss);
                #0:break;
             else  exit;
      end;
    end;
  if Miss > 1 then exit;
  Lin := strTofloat(LL);
  if Lin < 0 then exit;
  if Lin < L1in then L1in := 0;
  if Xin > Lin then Xin := -1;
  Dataf := 0;
  Inputdata;              {͑I}
end;

procedure Tplate.Lindisp; // ol[͕̒\
var
  II: integer;
const
  Pic1 = 95;
  Pic2 = 195;
  Pic3 = 325;
  Pleft = 50;
begin
  ClientHeight := 390;
  ClientWidth := 632;
  clear;
  Dataf := 5;
  Buttonoff;
  with Image1.Canvas do begin
    Font.Height := 18;
    Font.Color := clRed;
    Font.Style := [fsBold];
    TextOut(10,5,'ol[̒');
    Font.Height := 17;
    Font.Color := clFuchsia;
    Font.Style := [];
    pen.Color := clBlack;
    pen.Style := psSolid;
    pen.Width := 2;

    MoveTo(50 + Pleft,0 + Pic1);
    LineTo(250 + Pleft,0 + Pic1);
    LineTo(250 + Pleft,70 + Pic1);
    LineTo(50 + Pleft,70 + Pic1);
    LineTo(50 + Pleft,0 + Pic1);

    MoveTo(50 + Pleft, 0 + Pic2);
    LineTo(250 + Pleft,20 + Pic2);
    LineTo(250 + Pleft,70 + Pic2);
    LineTo(50 + Pleft,90 + Pic2);
    LineTo(50 + Pleft,0 + Pic2);

    MoveTo(50 + Pleft,0 + Pic3);
    LineTo(250 + Pleft,0 + Pic3);
    LineTo(250 + Pleft,5 + Pic3);
    LineTo(50 + Pleft,5 + Pic3);
    MoveTo(50 + Pleft,-12 + Pic3);
    LineTo(50 + Pleft,17 + Pic3);
    pen.Width := 1;
    for II := 0 to 5 do
      begin
        MoveTo(50 + Pleft,-12 + Pic3 + 5 * II);
        LineTo(30 + Pleft,-5 + Pic3 + 5 * II);
      end;

    MoveTo(50 + Pleft,-40 + Pic1);
    LineTo(50 + Pleft,-5 + Pic1);
    MoveTo(250 + Pleft,-40 + Pic1);
    LineTo(250 + Pleft,-5 + Pic1);
    MoveTo(50 + Pleft,-35 + Pic1);
    LineTo(250 + Pleft,-35 + Pic1);
    YA(50 + Pleft,-35 + Pic1, 0);
    YA(250 + Pleft,-35 + Pic1,pi);
    dleft := TextWidth('ol[̒');
    dtop := (250 - 50 - dleft) div 2;
    TextOut(50 + Pleft + dtop,-45 + Pic1,'ol[̒');

    MoveTo(250 + Pleft,75 + Pic1);
    LineTo(250 + Pleft,15 + Pic2);
    MoveTo(250 + Pleft,75 + Pic2);
    LineTo(250 + Pleft,-5 + Pic3);
    MoveTo(50 + Pleft,75 + Pic1);
    LineTo(50 + Pleft,-5 + Pic2);
    MoveTo(50 + Pleft,95 + Pic2);
    LineTo(50 + Pleft,-15 + Pic3);

    Font.Height := 15;
    Font.Color := clGreen;
    TextOut(230,360,'dŕύXɖ߂܂B');
    Font.Color := clBlue;
    TextOut(320,331,'Pʂmm');

    Datain.Font.Height := 16;
    Datain.top := 330;
    Datain.width := 70;
    Datain.Left := 400;
    OKBtn.Top := 330;
    OKBtn.Left := 480;
    OKBtn.Visible := True;
    Datain.Visible := True;
    if Lin = 0 then Datain.Text := ''
               else Datain.Text := floatTostr(Lin);
    Datain.SetFocus;
  end;
end;

procedure Tplate.B1ininput; // ol[͏
var
  IIL: integer;
begin
  Miss := 0;
  LL := Datain.text;
  inleng := length(LL);
  if inleng = 0 then exit;
  for IIL := 1 to inleng do
    begin
      chchar := LL[IIL];
      case chchar of
        '0'..'9':;
             '.':inc(Miss);
              #0:break;
            else exit;
      end;
    end;
  if Miss > 1 then exit;
  b1in := strTofloat(LL);
  if b1in < 0 then exit;
  if b1in > Bin then
    begin
      Image1.Canvas.Font.Color := clBlack;
      Image1.Canvas.TextOut(30,310,'̕LȂĂ܂B');
      Image1.Canvas.TextOut(30,327,'Lꍇ́Ał͓');
      Image1.Canvas.TextOut(30,344,'̕꒼Ăēx͂ĉB');
      exit;
    end;
  Dataf := 0;
  Inputdata;          {͑I}
end;

procedure Tplate.B1indisp;  // ol[͕\
var
  II: integer;
const
  Pic1 = 60;
  Pic2 = 160;
  Pic3 = 290;
begin
  ClientHeight := 390;
  ClientWidth := 632;
  clear;
  Dataf := 4;
  Buttonoff;
  with Image1.Canvas do begin
    Font.Height := 18;
    Font.Color := clRed;
    Font.Style := [fsBold];
    TextOut(10,5,'ol[̓');
    Font.Height := 17;
    Font.Color := clFuchsia;
    Font.Style := [];
    pen.Color := clBlack;
    pen.Style := psSolid;
    pen.Width := 2;
    MoveTo(250,0 + Pic1);
    LineTo(450,0 + Pic1);
    LineTo(450,70 + Pic1);
    LineTo(250,70 + Pic1);
    LineTo(250,0 + Pic1);
    pen.Width := 1;
    MoveTo(145,0 + Pic1);
    LineTo(245,0 + Pic1);
    MoveTo(145,70 + Pic1);
    LineTo(245,70 + Pic1);
    MoveTo(150,0 + Pic1);
    LineTo(150,70 + Pic1);
    YA(150,0 + Pic1,pi/2);
    YA(150,70 + Pic1,pi + pi/2);
    MoveTo(455,0 + Pic1);
    LineTo(550,0 + Pic1);
    MoveTo(455,70 + Pic1);
    LineTo(550,70 + Pic1);
    MoveTo(545,0 + Pic1);
    LineTo(545,70 + Pic1);
    YA(545,0 + Pic1,pi/2);
    YA(545,70 + Pic1,pi + pi/2);
    TextOut(500,28 + Pic1,'ol[');

    Font.Style := [fsBold];
    TextOut(120,30 + Pic1,floatTostr(Bin) + 'mm');
    Font.Style := [];

    pen.Width := 2;

    MoveTo(250, 0 + Pic2);
    LineTo(450,20 + Pic2);
    LineTo(450,70 + Pic2);
    LineTo(250,90 + Pic2);
    LineTo(250,0 + Pic2);
    pen.Width := 1;
    MoveTo(145,0 + Pic2);
    LineTo(245,0 + Pic2);
    MoveTo(145,90 + Pic2);
    LineTo(245,90 + Pic2);
    MoveTo(150,0 + Pic2);
    LineTo(150,90 + Pic2);
    YA(150,0 + Pic2,pi/2);
    YA(150,90 + Pic2,pi + pi/2);
    MoveTo(455,20 + Pic2);
    LineTo(550,20 + Pic2);
    MoveTo(455,70 + Pic2);
    LineTo(550,70 + Pic2);
    MoveTo(545,20 + Pic2);
    LineTo(545,70 + Pic2);
    YA(545,20 + Pic2,pi/2);
    YA(545,70 + Pic2,pi + pi/2);
    TextOut(500,38 + Pic2,'ol[');
    Font.Style := [fsBold];
    TextOut(120,40 + Pic2,floatTostr(Bin) + 'mm');
    Font.Style := [];
    pen.Width := 2;
    MoveTo(250,0 + Pic3);
    LineTo(450,0 + Pic3);
    LineTo(450,5 + Pic3);
    LineTo(250,5 + Pic3);
    MoveTo(250,-12 + Pic3);
    LineTo(250,17 + Pic3);
    pen.Width := 1;
    for II := 0 to 5 do
      begin
        MoveTo(250,-12 + Pic3 + 5 * II);
        LineTo(230,-5 + Pic3 + 5 * II);
      end;
    Font.Height := 15;
    Font.Color := clGreen;
    TextOut(230,360,'dŕύXɖ߂܂B');
    Font.Color := clBlue;
    TextOut(320,331,'Pʂmm');
    Datain.Font.Height := 16;
    Datain.top := 330;
    Datain.width := 70;
    Datain.Left := 400;
    OKBtn.Top := 330;
    OKBtn.Left := 480;
    OKBtn.Visible := True;
    Datain.Visible := True;
    if b1in < 0 then Datain.Text := ''
                else Datain.Text := floatTostr(b1in);
    Datain.SetFocus;
  end;
end;

procedure Tplate.Bininput;  // ol͏
var
  IIL: integer;
begin
  Miss := 0;
  LL := Datain.text;
  inleng := length(LL);
  if inleng = 0 then exit;
  for IIL := 1 to inleng do
    begin
      chchar := LL[IIL];
      case chchar of
        '0'..'9':;
             '.':inc(Miss);
              #0:break;
            else exit;
      end;
    end;
  if Miss > 1 then exit;
  bin := strTofloat(LL);
  if bin <= 0 then exit;
  if bin < B1in then B1in := -1;
  Dataf := 0;
  Inputdata;              {͑I}
end;

procedure Tplate.Bindisp; // ol͕\
var
  II: integer;
const
  Pic1 = 60;
  Pic2 = 160;
  Pic3 = 290;
begin
  ClientHeight := 390;
  ClientWidth := 632;
  clear;
  Dataf := 3;
  Buttonoff;
  with Image1.Canvas do begin
    Font.Height := 18;
    Font.Color := clRed;
    Font.Style := [fsBold];
    TextOut(10,5,'oliŒ[j̓');
    Font.Height := 17;
    Font.Color := clFuchsia;
    Font.Style := [];
    pen.Color := clBlack;
    pen.Style := psSolid;
    pen.Width := 2;
    MoveTo(250,0 + Pic1);
    LineTo(450,0 + Pic1);
    LineTo(450,70 + Pic1);
    LineTo(250,70 + Pic1);
    LineTo(250,0 + Pic1);
    pen.Width := 1;
    MoveTo(145,0 + Pic1);
    LineTo(245,0 + Pic1);
    MoveTo(145,70 + Pic1);
    LineTo(245,70 + Pic1);
    MoveTo(150,0 + Pic1);
    LineTo(150,70 + Pic1);
    YA(150,0 + Pic1,pi/2);
    YA(150,70 + Pic1,pi + pi/2);
    TextOut(100,30 + Pic1,'ol');

    pen.Width := 2;

    MoveTo(250, 0 + Pic2);
    LineTo(450,20 + Pic2);
    LineTo(450,70 + Pic2);
    LineTo(250,90 + Pic2);
    LineTo(250,0 + Pic2);
    pen.Width := 1;
    MoveTo(145,0 + Pic2);
    LineTo(245,0 + Pic2);
    MoveTo(145,90 + Pic2);
    LineTo(245,90 + Pic2);
    MoveTo(150,0 + Pic2);
    LineTo(150,90 + Pic2);
    YA(150,0 + Pic2,pi/2);
    YA(150,90 + Pic2,pi + pi/2);
    TextOut(100,40 + Pic2,'ol');
    pen.Width := 2;
    MoveTo(250,0 + Pic3);
    LineTo(450,0 + Pic3);
    LineTo(450,5 + Pic3);
    LineTo(250,5 + Pic3);
    MoveTo(250,-12 + Pic3);
    LineTo(250,17 + Pic3);
    pen.Width := 1;
    for II := 0 to 5 do
      begin
        MoveTo(250,-12 + Pic3 + 5 * II);
        LineTo(230,-5 + Pic3 + 5 * II);
      end;
    Font.Height := 15;
    Font.Color := clGreen;
    TextOut(230,360,'dŕύXɖ߂܂B');
    Font.Color := clBlue;
    TextOut(320,331,'Pʂmm');
    Datain.Font.Height := 16;
    Datain.top := 330;
    Datain.width := 70;
    Datain.Left := 400;
    OKBtn.Top := 330;
    OKBtn.Left := 480;
    OKBtn.Visible := True;
    Datain.Visible := True;
    if bin = 0 then Datain.Text := ''
               else Datain.Text := floatTostr(bin);
    Datain.SetFocus;
  end;
end;

procedure Tplate.thicknessinput;  // ͏
var
  IIL: integer;
begin
  Miss := 0;
  LL := Datain.text;
  inleng := length(LL);
  if inleng = 0 then exit;
  for IIL := 1 to inleng do
    begin
      chchar := LL[IIL];
        case chchar of
          '0'..'9':;
               '.':inc(Miss);
                #0:break;
              else exit;
        end;
    end;
  if Miss > 1 then exit;
  hin := strTofloat(LL);
  if hin <= 0 then exit;
  Miss := 0;
  for IIL := 1 to 30 do
    begin
      if hin = thick[IIL] then
        begin
          case MatNo of
              1: inleng := thickSpc[IIL];
            2,3: inleng := thickstn[IIL];
              4: inleng := thickcup[IIL];
          end;
          if (inleng = 1) or (inleng = 3) or (inleng = 4) then Miss := 1  // f[^[vmF
                                                          else Miss := 0; // f[^[svmF
        end;
    end;
  if (Miss = 0) and (MatNo <> 5) then
    begin
      Image1.Canvas.Font.Color := clRed;
      Image1.Canvas.TextOut(30,310,'̓̓~XłB');
      Image1.Canvas.TextOut(30,327,'RȔ͂ꍇ́A');
      Image1.Canvas.TextOut(30,344,'ގIłTIĉB');
      exit;
    end;
  Dataf := 0;
  Inputdata;            {͑I}
end;

procedure Tplate.thicknessd;  // ͕\
var
  JJ: integer;
  const leftpich = 50;
begin
  ClientHeight := 385;
  ClientWidth := 632;
  clear;
  Dataf := 2;
  Buttonoff;
  with Image1.Canvas do begin
    Font.Height := 18;
    Font.Color := clRed;
    Font.Style := [fsBold];
    TextOut(10,5,'̓');
    Font.Height := 17;
    Font.Style := [];
    Font.Color := clFuchsia;
    if MatNo <> 5 then
      begin
        TextOut(125,35,'WƂč̗p');
        TextOut(125,52,'ihrŋK肵Ă邪̗pȂ');
        TextOut(125,69,'ɐ');
        TextOut(125,86,'ihrɂ͖̗p');
        Font.Color := clPurple;
        Font.Style := [fsBold];
        TextOut(100,35,'');
        TextOut(100,52,'');
        TextOut(100,69,'');
        TextOut(100,86,'');
      end
      else
      begin
        TextOut(100,35,'@ގɎRȃf[^[͂Î');
        TextOut(100,52,'\ɖł͏o܂B');
      end;
    pen.Color := clMaroon;
    pen.Style := psSolid;
    pen.Width := 1;
    for JJ := 0 to 3 do
      begin
        MoveTo(85,115 + 60 * JJ);
        LineTo(585,115 + 60 * JJ);
      end;
    for JJ := 0 to 2 do
      begin
        MoveTo(85,140 + 60 * JJ);
        LineTo(585,140 + 60 * JJ);
      end;
    for JJ := 0 to 10 do
      begin
        MoveTo(85 + 50 * JJ,115);
        LineTo(85 + 50 * JJ,115 + 60 * 3);
      end;

    for JJ := 1 to 30 do
      begin
        case MatNo of
          1: suisen := thickSpc[JJ];
          2: suisen := thickstn[JJ];
          3: suisen := thickstn[JJ];
          4: suisen := thickcup[JJ];
          5: suisen := 0;
        end;
        Font.Color := clBlue;
        if JJ <= 10 then
          begin
            dleft := 50 + leftpich * JJ;
            dtop := 120;
            TextOut(dleft,dtop,floatTostr(thick[JJ]));
          end;
        if (JJ > 10) and (JJ <= 20)then
          begin
            dleft := 50 + leftpich * (JJ - 10);
            dtop := 180;
            TextOut(dleft,dtop,floatTostr(thick[JJ]));
          end;
        if JJ > 20 then
          begin
            dleft := 50 + leftpich * (JJ - 20);
            dtop := 240;
            TextOut(dleft,dtop,floatTostr(thick[JJ]));
          end;
        Font.Color := clblack;
        if suisen = 1 then TextOut(dleft,dtop + 30,'');
        if suisen = 2 then TextOut(dleft,dtop + 30,'');
        if suisen = 3 then TextOut(dleft,dtop + 30,'');
        if suisen = 4 then TextOut(dleft,dtop + 30,'');
      end;
    Font.Style := [];
    Font.Height := 15;
    Font.Color := clGreen;
    TextOut(230,360,'dŕύXɖ߂܂B');
    Datain.Font.Height := 16;
    Datain.top := 330;
    Datain.width := 70;
    Datain.Left := 400;
    OKBtn.Top := 330;
    OKBtn.Left := 480;
    OKBtn.Visible := True;
    Datain.Visible := True;
    if hin = 0 then Datain.Text := ''
               else Datain.Text := floatTostr(hin);
    Datain.SetFocus;
  end;
end;

procedure Tplate.enginput;  // Oe͓͏
var
  IIL: integer;
begin
  Miss := 0;
  LL := Datain.text;
  inleng := length(LL);
  if inleng = 0 then exit;
  for IIL := 1 to inleng do
    begin
      chchar := LL[IIL];
      case chchar of
        '0'..'9':;
             '.':inc(Miss);
              #0:break;
            else exit;
      end;
    end;
  if Miss > 1 then exit;
  Eng[MatNo] := strTofloat(LL);
  if Eng[MatNo] <= 0 then exit;

  Miss := 0;
  LL := Datainb.text;
  inleng := length(LL);
  if inleng = 0 then exit;
  for IIL := 1 to inleng do
    begin
      chchar := LL[IIL];
      case chchar of
        '0'..'9':;
             '.':inc(Miss);
              #0:break;
            else exit;
      end;
    end;
  if Miss > 1 then exit;
  str[MatNo] := strTofloat(LL);
  if str[MatNo] <= 0 then exit;
  Dataf := 0;
  Inputdata;          {͑I}
end;


procedure Tplate.inputeng;  // Oe͓
var
  KK: integer;
begin
  ClientHeight := 335;
  ClientWidth := 435;
  clear;
  Dataf := 6;
  Buttonoff;
  with Image1.Canvas do begin
    Font.Name := 'lr ';
    Font.Height := 17;
    Font.Color := clRed;
    TextOut(10,5,'ceWAގx̓');
    Font.Height := 14;
    Font.Color := clMaroon;
    TextOut(30,40,'ceWAގxiéj̒l͂ĉB');
    TextOut(50,200,'Pʂ́Am^mm');
    inleng := 50 + TextWidth('Pʂ́Am^mm');
    Font.Height := 12;
    TextOut(inleng,197,'2');
    inleng := inleng + TextWidth('2');
    Font.Height := 14;
    TextOut(inleng,200,'łB');
    inleng := inleng + TextWidth('łB');
    Font.Color := clBlack;
    TextOut(100,220,'ceW');
    Font.Color := clNavy;
    TextOut(100,250,'e@');
    Font.Color := clPurple;
    TextOut(30,67,'ceQll');
    for KK := 1 to 5 do
      begin
        Font.Color := clBlack;
        if KK < 5 then
          begin
            TextOut(50, KK * 16 + 70, matname[KK]);
            Font.Color := clBlue;
            TextOut(250, KK * 16 + 70,floatTostrF(Eng[KK],ffFixed,10,0));
          end
          else
          begin
            Font.Color := clLime;
            TextOut(50, KK * 16 + 80, 'O' + matname[KK]);
            Font.Color := clBlue;
            if (Eng[KK] = 0) or (str[KK] = 0) then
              begin
                TextOut(250, KK * 16 + 80,'f[^[');
              end
              else
              begin
                TextOut(230, KK * 16 + 80, 'ceW@' + floatTostrF(Eng[KK],ffFixed,10,0));
                TextOut(230, (KK + 1) * 16 + 80, 'e@́@' + floatTostrF(str[KK],ffFixed,10,2));
              end;
          end;
      end;
    Font.Height := 14;
    Font.Color := clblue;
    TextOut(30,280,'e͂s̏ꍇ́A苭x̂VOx');
    TextOut(30,295,'lgpĉB');
    Font.Color := clGreen;
    TextOut(130,315,'dŕύXɖ߂܂B');
    Datain.Font.Height := 16;
    Datain.top := 220;
    Datain.Left := inleng;
    Datain.width := 70;
    Datainb.Font.Height := 16;
    Datainb.top := 250;
    Datainb.Left := inleng;
    Datainb.width := 70;

    OKBtn.Top := 220;
    OKBtn.Left := 300;
    OKBtn.Visible := True;
    Datain.Visible := True;
    Datainb.Visible := True;
    if Eng[MatNo] = 0 then Datain.Text := ''
                      else Datain.Text := floatTostr(Eng[MatNo]);
    if str[MatNo] = 0 then Datainb.Text := ''
                      else Datainb.Text := floatTostr(str[MatNo]);
    Datain.SetFocus;
  end;
end;

procedure Tplate.matinput;  {ގԍ͏}
var
  IIL : integer;
begin
  LL := Datain.text;
  inleng := length(LL);
  if inleng = 0 then
    begin
      Inputdata;            {͑I}
      exit;
    end;
  for IIL := 1 to inleng do
    begin
      chchar := LL[IIL];
      case chchar of
        '1'..'5':;
              #0:break;
            else exit;
      end;
    end;
  IIL := strToint(LL);
  if (IIL < 1) or (IIL > zaiNo) then exit;
  if MatNo <> IIL then hin := 0;
  MatNo:= IIL;
  if MatNo = 5 then
    begin
      inputeng;         // O
      exit;
    end;
  Inputdata;        {͑I}
end;

procedure Tplate.Inputdata; {͑I}
var
  LLeng: integer;
begin
  ClientHeight := 390;
  ClientWidth := 632;
  clear;
  ButtonOn;
  Button1.Visible := true;
  Button2.Visible := true;
  come.Visible := true;
  OKBtn.Visible := False;
  Datain.Visible := False;
  Datainb.Visible := False;
  printbtn.Visible := False;
  calcbtn.Visible := False;
  returnbtn.Visible := False;
  loading.Visible := False;
  bending.Visible := False;
  strength.Visible := False;
  with Image1.Canvas do begin
    Font.Name := 'lr ';
    Font.Style := [];
    Font.Height := 17;
    Font.Color := clBlue;
    TextOut(20,3,'ЎolvZ');
    Font.Height := 15;
    Font.Color := clBlack;
    if typef and 1 > 1 then TextOut(300,3,'׏dwvZ')  // 1 ׏dwvZ@Q@ݎwvZ
                       else TextOut(300,3,'ݎwvZ');
    Font.Color := clFuchsia;
    TextOut(50,25,'vZốAŁA`̂̂ƁA`̂̂łB');
    TextOut(50,40,'{A\̕␳͂܂B');
    Font.Color := clGreen;
    TextOut(50,55,'ʓIɁAlW~߁AJVsꍇAݕ̍̌Œ肪');
    TextOut(50,70,'SłȂׁAvZ傫݂܂B');
    Font.Color := clMaroon;
    TextOut(50,85,'߂ɓ͂ǂł傤B');
    Font.Height := 17;
    LLeng := 50 + TextWidth('{A\̕␳͂܂B');
    Font.Height := 13;
    Font.Color := clblack;
    TextOut(LLeng,40,'␳ĺA(1-');
    LLeng := LLeng + TextWidth('␳ĺA(1-');
    TextOut(LLeng,37,'2');
    LLeng := LLeng + TextWidth('2');
    TextOut(LLeng,40,')@=߱ݔ łB');
    Font.Height := 17;
    Focusd := 0;
    if MatNo = 0 then
      begin
        Font.Color := clRed;
        TextOut(180,yposk,'');
        Focusd := 1;
      end
      else
      begin
        if hin > 0 then
          begin
            h := hin;
            thicknessk; // ␳TƂĐʃf[^[␳B
          end;
        if MatNo = 5 then
          begin
            if (Eng[MatNo] = 0) or (str[MatNo] = 0) then
              begin
                Font.Color := clRed;
                TextOut(180,yposk,'');
                Focusd := 1;
              end
              else
              begin
                Font.Height := 14;
                Font.Color := clBlack;
                TextOut(180,yposk,matname[MatNo]);
                LLeng :=180 + 10 + TextWidth(matname[MatNo]);
                TextOut(LLeng,yposk,'ceW ' + floatTostr(Eng[MatNo]) + ' m/mm');
                LLeng := LLeng + TextWidth('ceW ' + floatTostr(Eng[MatNo]) + ' m/mm');
                Font.Height := 11;
                TextOut(LLeng,yposk - 3,'2');
                LLeng := LLeng + TextWidth('2');
                Font.Height := 14;
                TextOut(LLeng,yposk,'@é@' + floatTostr(str[MatNo]) + ' m/mm');
                LLeng := LLeng + TextWidth('@é@' + floatTostr(str[MatNo]) + ' m/mm');
                Font.Height := 11;
                TextOut(LLeng,yposk - 3,'2');
              end;
          end
          else
          begin
            Font.Height := 17;
            Font.Color := clBlack;
            TextOut(180,yposk,matname[MatNo]);
            LLeng :=180 + 10 + TextWidth(matname[MatNo]);
            TextOut(LLeng,yposk,'ceW ' + floatTostr(Eng[MatNo]) + ' m/mm');
            LLeng := LLeng + TextWidth('ceW ' + floatTostr(Eng[MatNo]) + ' m/mm');
            Font.Height := 14;
            TextOut(LLeng,yposk - 3,'2');
          end;
      end;
    Font.Height := 17;
    if MatNo > 0 then
      begin
        if hin = 0 then
          begin
            Font.Color := clRed;
            TextOut(180,yposk + bpich,'');
            if Focusd = 0 then Focusd := 2;
          end
          else
          begin
            Font.Color := clBlack;
            TextOut(180,yposk + bpich,'@@@@@@' + floatTostr(hin) + ' mm');
          end;
      end;
    if Bin = 0 then
      begin
        Font.Color := clRed;
        TextOut(180,yposk + bpich * 2,'');
        if Focusd = 0 then Focusd := 3;
      end
      else
      begin
        Font.Color := clBlack;
        TextOut(180,yposk + bpich * 2,'ol@@' + floatTostr(Bin) + ' mm');
      end;
    if Bin > 0 then
      begin
        if Bin < B1in then B1in := -1;
        if B1in < 0 then
          begin
            Font.Color := clRed;
            TextOut(180,yposk + bpich * 3,'');
            if Focusd = 0 then Focusd := 4;
          end
          else
          begin
            Font.Color := clBlack;
            TextOut(180,yposk + bpich * 3,'ol[@@' + floatTostr(B1in) + ' mm');
          end;
      end;
    if Lin = 0 then
      begin
        Font.Color := clRed;
        TextOut(180,yposk + bpich * 4,'');
        if Focusd = 0 then Focusd := 5;
      end
      else
      begin
        Font.Color := clBlack;
        TextOut(180,yposk + bpich * 4,'[̒@@' + floatTostr(Lin) + ' mm');
      end;
    if Lin > 0 then
      begin
        if L1in = 0 then
          begin
            Font.Color := clRed;
            TextOut(180,yposk + bpich * 5,'');
            if Focusd = 0 then Focusd := 6;
          end
          else
          begin
            Font.Color := clBlack;
            TextOut(180,yposk + bpich * 5,'׏d_̒@' + floatTostr(L1in) + ' mm');
          end;
      end;
    if typef and 1 > 0 then
      begin
        if Pin < 0 then
          begin
            Font.Color := clRed;
            TextOut(180,yposk + bpich * 6,'');
            if Focusd = 0 then Focusd := 7;
          end
          else
          begin
            Font.Color := clBlack;
            TextOut(180,yposk + bpich * 6,'׏d@@@@@@' + floatTostrF(Pin,ffGeneral,10,3) + ' N');
          end;
      end
      else
      begin
        if zin < 0 then
          begin
            Font.Color := clRed;
            TextOut(180,yposk + bpich * 6,'');
            if Focusd = 0 then Focusd := 7;
          end
          else
          begin
            Font.Color := clBlack;
            TextOut(180,yposk + bpich * 6,'׏dʒuݗʁ@' + floatTostrF(zin,ffGeneral,10,3) + ' mm');
          end;
      end;
    if L1in > 0 then
      begin
        if (Xin < 0) or (Lin < Xin) then Xin := Lin;
        Font.Color := clBlack;
        TextOut(180,yposk + bpich * 7,'݌vZwʒu@' + floatTostr(Xin) + ' mm');
      end;

    Font.Height := 17;
    case Focusd of
      0:begin
          calcbtn.Visible := true;
          calcbtn.SetFocus;
        end;
      1:material.SetFocus;
      2:thickness.SetFocus;
      3:Bwidth.SetFocus;
      4:Swidth.SetFocus;
      5:lengsen.SetFocus;
      6:loadp.SetFocus;
      7:if typef and 1 > 0 then Load.SetFocus
                           else bend.SetFocus;
      8:tawabtn.SetFocus;
    end;
  end;
end;

procedure Tplate.ButtonOn;
begin
  material.Visible := True;
  typeret.Visible := True;
  if MatNo > 0 then thickness.Visible := True
               else thickness.Visible := False;
  Bwidth.Visible := True;
  if Bin > 0 then Swidth.Visible := True
             else Swidth.Visible := False;
  lengsen.Visible := True;
  if Lin > 0 then loadp.Visible := True
             else loadp.Visible := False;
  if L1in > 0 then tawabtn.Visible := True
              else tawabtn.Visible := False;
  if typef and 1 > 0 then
    begin
      Load.Visible := True;
      bend.Visible := False;
    end
    else
    begin
      Load.Visible := False;
      bend.Visible := True;
    end;
  OKbtn.Height := 25;
  material.Height := 25;
  thickness.Height := 25;
  Bwidth.Height := 25;
  Swidth.Height := 25;
  loadp.Height := 25;
  lengsen.Height := 25;
  Load.Height := 25;
  bend.Height := 25;
  tawabtn.Height := 25;
  calcbtn.Height := 25;
  material.Top := yposbtn;
  thickness.Top := yposbtn + bpich;
  Bwidth.Top := yposbtn + bpich * 2;
  Swidth.Top := yposbtn + bpich * 3;
  lengsen.Top := yposbtn + bpich * 4;
  loadp.Top := yposbtn + bpich * 5;
  Load.Top := yposbtn + bpich * 6;
  bend.Top := yposbtn + bpich * 6;
  tawabtn.Top := yposbtn + bpich * 7;
  calcbtn.Top := yposbtn + bpich * 8;
  material.Left := 72;
  thickness.Left := 72;
  Bwidth.Left := 72;
  Swidth.Left := 72;
  loadp.Left := 72;
  lengsen.Left := 72;
  Load.Left := 72;
  bend.Left := 72;
  tawabtn.Left := 72;
  calcbtn.Left := 72;
  material.Width := 100;
  thickness.Width := 100;
  Bwidth.Width := 100;
  Swidth.Width := 100;
  loadp.Width := 100;
  lengsen.Width := 100;
  Load.Width := 100;
  bend.Width := 100;
  tawabtn.Width := 100;
  calcbtn.Width := 100;
  OKbtn.Width := 65;
  Button1.Top := 8;
  Button1.Left := 544;
  Button1.Height := 25;
  Button1.Width := 25;
  Button2.Top := 8;
  Button2.Left := 592;
  Button2.Height := 25;
  Button2.Width := 25;
  typeret.top := 335;
  typeret.left := 470;
  typeret.height := 25;
  typeret.width := 137;
  come.top := 85;
  come.left := 320;
  come.Height := 16;
  come.width := 16;
  come.Font.Height := 10;
  come.Caption := '!';
end;

procedure Tplate.Buttonoff;
begin
  material.Visible := False;
  thickness.Visible := False;
  Bwidth.Visible := False;
  Swidth.Visible := False;
  loadp.Visible := False;
  lengsen.Visible := False;
  Load.Visible := False;
  Bend.Visible := False;
  tawabtn.Visible := False;
  calcbtn.Visible := False;
  returnbtn.Visible := False;
  printbtn.Visible := False;
  fatigue.Visible := False;
  loading.Visible := False;
  bending.Visible := False;
  typeret.Visible := False;
  strength.Visible := False;
  come.Visible := False;
end;

procedure Tplate.FormCreate(Sender: TObject);
begin
  Caption := Verdis;
  ClientHeight := 350;
  ClientWidth := 350;
  CLEAR;
  OKBtn.Visible := False;
  Datain.Visible := False;
  Datainb.Visible := False;
  printbtn.Visible := False;
  calcbtn.Visible := False;
  returnbtn.Visible := False;
  Button1.Visible := False;
  Button2.Visible := False;
  Buttonoff;
  startdemo;  // Nf

//  ButtonOn;
//  P := 5;  //1j[g
//  L1 := 30;//׏d_
//  L := 40;//ol
//  X := 30;//݈ʒu
//  B := 20;//ol
//  B1 := 8;//ol[
//  h := 0.5;//
//  E := 205800;//ceW
//  calc;//vZ
//  Timer1.Enabled := true;
end;

procedure Tplate.CtextOut;  // vZ
var
  KK: integer;
  Bx : double;              // ݌vZʒu
const
  Kypos = 270;
begin
  calcin;                   // vZJn
  if typef and 2 > 0 then
    begin
      zcin := zin;
      Zincalc;              // ׏dvZ
      Pin := P;
    end;
  if omega > 1 then exit;
  Ouriocalc;                // ͏CWvZ
  ramudaMax := ramuda;
  s := 6 * Pin * L1in / Bin / hin / hin * ramudaMax;  // ő剞͌vZ
  Bx :=Bin - (Bin - B1in) / Lin * Xin;
  if L1in > Xin then
    begin
      sx := 6 * Pin * (L1in - Xin) / Bx / hin / hin; //wʒu͌vZ
      sx := sx * ramudaMax;
    end
    else sx := 0;
  Miss := ClientWidth - 50 - 200;
  xkeisu := Miss / Lin;
  L1 := L1in;
  B := bin;
// [ݗʂ̌vZ@@ׯ̨p[őlvZ
  if Bin > B1in then
    begin
      Lpich := L1in / calck;  // vZB`͉׏d_܂
    end
    else
    begin
      Lpich := Lin / calck;
      B1 := B1in;
    end;
  zxback := 0;
  suisen := 0;
  for KK := 1 to calck do
    begin
      X := Lpich * KK;
      if Bin > B1in then      // `́A݌vZʒȗ׏dA[vZ
        begin                 // ްvZƂB
          B1 := Bin - (Bin - B1in) / Lin * X;
          L1 := X;
          P := Pin  * L1in / X + Pin * (L1in - X) / X / phk;
        end;
      calc;                   // vZ
      if Lpich < z - zxback then
        begin
          Image1.Canvas.Font.Color := clred;
          Image1.Canvas.TextOut(180,yposk + bpich * 8,'׏d傫vZs');
          suisen := 1;
          exit;
        end;
      zxback := z;
      if Bin > b1in then
        begin
          if KK = calck - 1 then zback := z;    // `́AŌ̝݂ƁAO̝݂̕ω
                                                // 撼ƂČvZA[̝ݗʏȂȂB

          if KK = calck then zsout := z + (z - zback) / Lpich * (Lin - L1in);
        end
        else zsout := z;
    end;
  ykeisu := xkeisu;
  dtop := round(ykeisu * zsout) + 370;
  ClientHeight := dtop;
  if Height > screen.Height then
    begin
      height := screen.Height;
      dtop := ClientHeight - 370;
      ykeisu := dtop / zsout;
    end
    else
    begin
      ClientHeight := dtop;
      dtop := ClientHeight - 370;
    end;
  ClientWidth := 632;
  clear;
  with Image1.Canvas do begin
    Font.Height := 17;
    Font.Name := 'lr ';
    Font.Style := [fsBold];
    Font.Color := clBlue;
    TextOut(10,5,'vZ');
    Font.Color := clBlack;
    Font.Style := [];
    TextOut(20,60,'ő剞');
    TextOut(200,60,floatTostrF(s,ffFixed,10,3));
    Font.Color := clBlue;
    TextOut(300,60,'N/mm');
    dleft := TextWidth('N/mm') + 300;
    Font.Height := 14;
    TextOut(dleft,58,'2');
    Font.Height := 17;
    if s > stsmax then
      begin
        Font.Color := clRed;
        TextOut(360,60,'e͂zĂ');
      end;
    Font.Color := clBlack;
    TextOut(20,100,'wʒu');
    TextOut(200,100,floatTostrF(sx,ffFixed,10,3));
    Font.Color := clBlue;
    TextOut(300,100,'N/mm');
    dleft := TextWidth('N/mm') + 300;
    Font.Height := 14;
    TextOut(dleft,98,'2');
    Font.Height := 17;
    Font.Color := clBlack;
    TextOut(20,120,'wʒuXgC');
    TextOut(200,120,floatTostrF(sx / E * 1000000,ffFixed,10,3));
    Font.Color := clBlue;
    TextOut(300,120,'strain(ϲ۽ڲ)');
    Font.Color := clBlack;
    TextOut(20,140,'é@@');
    TextOut(200,140,floatTostrF(stsmax,ffFixed,10,3));
    Font.Color := clBlue;
    TextOut(300,140,'N/mm');
    dleft := TextWidth('N/mm') + 300;
    Font.Height := 14;
    TextOut(dleft,138,'2');
    Font.Color := clred;
    if MatNo <> 5 then TextOut(360,140,'imȃf[^[ׁAQllłj');
    Font.Height := 17;

    returnbtn.top := 320 + dtop;
    printbtn.top := 320 + dtop;
    strength.Top := 320 + dtop;

    Pen.Width := 2;
    MoveTo(50,kypos);
    xpos := 0;
    zxback := 0;
    for KK := 1 to calck do
      begin
        X := Lpich * KK;
        if Bin > B1in then
          begin
            B1 :=Bin - (Bin - B1in) / Lin * X;
            L1 := X;
            P := Pin  * L1in / X + Pin * (L1in - X) / X / phk;
          end;
        calc;           // vZ
        xpos := xpos + sqrt(Lpich * Lpich - (z - zxback) * (z - zxback));
        zxback := z;
        LineTo(50 + round(xpos * xkeisu),kypos + round(z * ykeisu));
        if Bin > b1in then
          begin
            if KK = calck - 1 then zback := z;
            if KK = calck then
              begin
                zout := z + (z - zback) / Lpich * (Lin - L1in);
                xpos := xpos + sqrt((Lin - L1in) * (Lin - L1in) - (z - zout) * (z - zout));
                LineTo(50 + round(Xpos * xkeisu),kypos + round(zout * ykeisu));
                zxback := zout;
                if Xin <= L1in then
                  begin
                    B1 := Bin - (Bin - B1in) / Lin * Xin; // Xin̕vZ
                    L1 := Xin;                            // Xin׏d_ɂBc̉׏d͉ł
                    X :=  Xin;
                    if X = 0 then P := 0
                             else P := Pin  * L1in / X + Pin * (L1in - X) / X / phk;
                    calc;                                 // vZ
                    zout := z;
                  end
                  else zout := z + (z - zback) / Lpich * (Xin - L1in); // ׏d_𒴂Ăꍇ@ω萄
              end;
          end
          else
          begin
            X := Xin;
            L1 := L1in;
            P := Pin;
            calc;         // vZ
            zout := z;
          end;
      end;

    Pen.Width := 1;
    MoveTo(50 + round(Xpos * xkeisu) + 5,kypos + round(zsout * ykeisu));
    LineTo(50 + 450,kypos + round(zsout * ykeisu));
    MoveTo(50 + round(Lin * xkeisu) + 5,kypos);
    LineTo(50 + 450,kypos);
    if round(zsout * ykeisu) < 20 then
      begin
        MoveTo(50 + 445,kypos + round(zsout * ykeisu) + 15);
        LineTo(50 + 445,kypos - 15);
        Ya(50 + 445,kypos + round(zsout * ykeisu),pi / 2);
        Ya(50 + 445,kypos,pi + pi / 2);
      end
      else
      begin
        MoveTo(50 + 445,kypos + round(zsout * ykeisu));
        LineTo(50 + 445,kypos);
        Ya(50 + 445,kypos + round(zsout * ykeisu),pi + pi / 2);
        Ya(50 + 445,kypos,pi / 2);
      end;
    TextOut(50 + 450,kypos + round(zsout * ykeisu / 2) - 5,floatTostrF(zsout,ffFixed,10,3));

    // ׏d_݌vZ
    X := L1in;
    L1 := L1in;
    P := Pin;
    if Bin > B1in then B1 := Bin - (Bin - B1in) / Lin * L1in
                  else B1 := B1in;
    calc;           // vZ
    zpout := z;

    Pen.Width := 1;
    MoveTo(50,kypos - 5);
    LineTo(50,kypos - 100);
    MoveTo(50,kypos);
    LineTo(50 + round(Lin * xkeisu),kypos);
    font.Height := 16;
    if Xin < L1in then
      begin
        MoveTo(50 + round(xin * xkeisu),kypos - 5);
        LineTo(50 + round(Xin * xkeisu),kypos - 40);
        MoveTo(50,kypos - 35);
        LineTo(50 + round(Xin * xkeisu),kypos - 35);
        Ya(50,kypos - 35,0);
        Ya(50 + round(Xin * xkeisu),kypos - 35,pi);

        LL := 'vZwʒu';
        inleng := TextWidth(LL);
        dleft := 50 + (round(xin * xkeisu) - inleng) div 2;
        font.Color := clFuchsia;
        if dleft < 50 then TextOut(dleft,kypos - 40 - 16,LL)
                      else TextOut(dleft,kypos - 43,LL);

        MoveTo(50 + round(L1in * xkeisu),kypos - 5);
        LineTo(50 + round(L1in * xkeisu),kypos - 70);
        MoveTo(50,kypos - 65);
        LineTo(50 + round(L1in * xkeisu),kypos - 65);
        Ya(50,kypos - 65,0);
        Ya(50 + round(L1in * xkeisu),kypos - 65,pi);

        LL := '׏dʒu';
        inleng := TextWidth(LL);
        dleft := 50 + (round(L1in * xkeisu) - inleng) div 2;
        font.Color := clFuchsia;
        if dleft < 50 then TextOut(dleft,kypos - 70 - 16,LL)
                      else TextOut(dleft,kypos - 73,LL);
      end
      else
      begin
        MoveTo(50 + round(L1in * xkeisu),kypos - 5);
        LineTo(50 + round(L1in * xkeisu),kypos - 40);
        MoveTo(50,kypos - 35);
        LineTo(50 + round(L1in * xkeisu),kypos - 35);
        Ya(50,kypos - 35,0);
        Ya(50 + round(L1in * xkeisu),kypos - 35,pi);
        LL := '׏dʒu';
        inleng := TextWidth(LL);
        dleft := 50 + (round(L1in * xkeisu) - inleng) div 2;
        font.Color := clFuchsia;
        if dleft < 50 then TextOut(dleft,kypos - 40 - 16,LL)
                      else TextOut(dleft,kypos - 43,LL);

        MoveTo(50 + round(Xin * xkeisu),kypos - 5);
        LineTo(50 + round(Xin * xkeisu),kypos - 70);
        MoveTo(50,kypos - 65);
        LineTo(50 + round(Xin * xkeisu),kypos - 65);
        Ya(50,kypos - 65,0);
        Ya(50 + round(Xin * xkeisu),kypos - 65,pi);
        LL := 'wʒu';
        inleng := TextWidth(LL);
        dleft := 50 + (round(xin * xkeisu) - inleng) div 2;
        font.Color := clFuchsia;
        if dleft < 50 then TextOut(dleft,kypos - 70 - 16,LL)
                      else TextOut(dleft,kypos - 73,LL);
      end;

    MoveTo(50 + round(Lin * xkeisu),kypos - 5);
    LineTo(50 + round(Lin * xkeisu),kypos - 100);
    MoveTo(50,kypos - 95);
    LineTo(50 + round(Lin * xkeisu),kypos - 95);
    Ya(50,kypos - 95,0);
    Ya(50 + round(Lin * xkeisu),kypos - 95,pi);
    LL := floatTostrF(Lin,ffGeneral,10,3) + ' mm';
    inleng := TextWidth(LL);
    dleft := 50 + (round(Lin * xkeisu) - inleng) div 2;
    font.Height := 16;
    font.Color := clFuchsia;
    TextOut(dleft,kypos - 103,LL);

    Font.Height := 16;
    Font.Color := clBlack;
    TextOut(20,40,'wʒuݗ');
    TextOut(200,40,floatTostrF(zout,ffFixed,10,3));
    Font.Color := clBlue;
    TextOut(300,40,'mm');
    Font.Height := 16;
    Font.Color := clBlack;
    TextOut(20,80,'[ݗ');
    TextOut(200,80,floatTostrF(zsout,ffFixed,10,3));
    Font.Color := clBlue;
    TextOut(300,80,'mm');
    TextOut(20,300,'׏dʒuݗ');
    TextOut(200,300,floatTostrF(zpout,ffFixed,10,3));
    Font.Color := clBlue;
    TextOut(300,300,'mm');
    if zpout/L1in > 0.2 then
      begin
        Font.Color := clRed;
        TextOut(350,300,'݂傫̒');
      end;
    Font.Color := clBlack;
    TextOut(50,320,'坚݌W @' + floatTostrF(phi,ffFixed,10,6));
    TextOut(50,340,'͏CW ' + floatTostrF(ramudaMax,ffFixed,10,6));
    Font.Color := clRed;
    if typef and 2 > 0 then TextOut(20,280,'׏d@@@ @' + floatTostrF(P,ffFixed,10,6) + 'N');
  end;
  Buttonoff;
  OKBtn.Visible := False;
  Datain.Visible := False;
  Datainb.Visible := False;
  printbtn.Visible := true;
  calcbtn.Visible := False;
  returnbtn.Visible := true;
  strength.Visible := true;
  returnbtn.Left := 300;
  strength.Left := 400;
  printbtn.Left := 500;
  returnbtn.Height := 25;
  printbtn.Height := 25;
  strength.Height := 25;
  returnbtn.Width := 100;
  printbtn.Width := 100;
  strength.Width := 100;
end;

procedure Tplate.calcin;// vZJn
begin
  E := eng[MatNo];
  Bm := Bin * hin * hin * hin * E / 12; // Ȃ
  omega := Pin * L1in * L1in / Bm;
  P := Pin;   // ׏d͒l
  L1:= L1in;  // ׏d_͒l
  L := Lin;   // ol͒l
  B := Bin;   // ol͒l
  h := hin;   // ͒l
  if B1in < Bin then
    begin
      B1 := bin - (Bin - B1in) / Lin * L1in;
      X := L1in;
    end
    else
    begin
      B1:= B1in;  // ol[͒l
      X := Xin;
    end;
  with Image1.Canvas  do begin
    if omega > 1 then
      begin
        Font.Height := 15;
        Font.Color := clred;
        TextOut(180,yposk + bpich * 8,'ݑvZs ');

        dleft := 180 + TextWidth('ݑvZs ');
        zback := 1 / L1in /L1in * bm;
        zback := int(zback * 1000) /1000;
        TextOut(dleft,yposk + bpich * 8,'׏dő ' + floatTostrF(zback,ffFixed,10,3) + ' N');
      end;
  end;
end;

procedure Tplate.calc;  // vZ
begin
  M := b1 / b;
  Bm := B * h * h * h * E / 12; // Ȃ
  tawamiKcalc;                  // 坚݌WvZ
  if L1 = 0 then
    begin
      z := 0;
      exit;
    end;
  if b1 < b then                // X̕aP̝̎
    begin
      kn := phi;
      z := kn * P * L1 * L1 * L1 / 3 / Bm; // 
    end
    else
    begin
      if L1 > X then z := P * L1 * X * X / 6 / Bm * (3 - X / L1)        // 
                else z := P * L1 * L1 * L1 / 6 / Bm * (3 * X / L1 - 1); // 
      z := z * phi;
    end;

end;

procedure Tplate.materialClick(Sender: TObject);
var
  JJ : integer;
begin
  ClientHeight := 297;
  ClientWidth := 632;
  clear;
  Dataf := 1;
  Buttonoff;
  with Image1.Canvas do begin
    Font.Height := 17;
    Font.Color := clRed;
    TextOut(10,5,'ގ̑I');
    Font.Height := 15;
    Font.Color := clMaroon;
    TextOut(30,30,'ގIĉB');
    TextOut(30,50,'ōގ̃f[^[͂ꍇ́ATw肵ĉB');
    For JJ := 1 to zaiNo do
      begin
        Font.Color := clBlack;
        TextOut(50,20 * JJ + 80,intTostr(JJ));
        Font.Color := clBlue;
        TextOut(100,20 * JJ + 80,matname[JJ]);
      end;
    Font.Color := clFuchsia;
    TextOut(30,240,'ގ̔ԍ͂ĉ');
    TextOut(30,255,'ގ̃f[^[œ͂ꍇ́A'+ intTostr(zaiNo) + ' łB');
    Font.Color := clGreen;
    TextOut(230,275,'dŕύXɖ߂܂B');
  end;
  Datain.Font.Height := 15;
  Datain.top := 250;
  Datain.Left := 400;
  Datain.width := 70;
  OKBtn.Top := 250;
  OKBtn.Left := 528;
  OKBtn.Visible := True;
  Datain.Visible := True;
  if MatNo = 0 then Datain.Text := ''
               else Datain.Text := intTostr(MatNo);
  Datain.SetFocus;
end;

procedure Tplate.OKBtnClick(Sender: TObject);
begin
  case Dataf of
    1:matinput;       {ގԍ͏}
    2:thicknessinput; // ͏
    3:Bininput;       // ol͏
    4:B1ininput;      // ol[͏
    5:Lininput;       // ol[̒͏
    6:enginput;       // O͏
    7:L1ininput;      // ׏d_̒͏
    8:Pininput;       // ׏d͏
    9:tawaminput;     // ݈ʒu͏
    10:Zininput;      // ݑ傫͏
    11:strainindata;  // ݉׏dgp͈͓͏
    12:CtextOut;      // vZ
  end;
end;

procedure Tplate.DatainKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then if Dataf <> 11 then Inputdata{͑I}
                                   else CtextOut; // vZ
  if key <> #13 then exit;  // 񂽁[ȂI
  case Dataf of
    1:matinput;          {ގԍ͏}
    2:thicknessinput;   // ͏
    3:Bininput;         // ol͏
    4:B1ininput;        // ol[͏
    5:Lininput;         // ol[̒͏
    6:enginput;         // O͏
    7:L1ininput;        // ׏d_̒͏
    8:Pininput;         // ׏d͏
    9:tawaminput;       // ݈ʒu͏
    10:Zininput;        // ݑ傫͏
    11:strainindata;    // ݉׏dgp͈͓͏
  end;
  Key := #0;
end;

procedure Tplate.thicknessClick(Sender: TObject);
begin
  thicknessd;           // ͕\
end;

procedure Tplate.Timer1Timer(Sender: TObject);
begin
  if timerF > 0 then inc(TimerF);
  if timerF > 2 then
    begin
      timerF := 0;
      Timer1.Enabled := False;
      BorderStyle := bsSingle;
      typeinput;        // vZ@̎w@׏dw肩ݎw肩
      top := (screen.Height - plate.Height) div 2;
      Left := (screen.Width - plate.Width) div 2;
    end;
end;

procedure Tplate.BwidthClick(Sender: TObject);
begin
  Bindisp;
end;

procedure Tplate.SwidthClick(Sender: TObject);
begin
  B1indisp;             // ol[͕\
end;

procedure Tplate.lengsenClick(Sender: TObject);
begin
  Lindisp;              // ol[͕̒\
end;

procedure Tplate.loadpClick(Sender: TObject);
begin
  L1indisp;             // ׏d_͕̒\
end;

procedure Tplate.LoadClick(Sender: TObject);
begin
  Pindisp;              // ׏d͕\
end;

procedure Tplate.calcbtnClick(Sender: TObject);
begin
  CtextOut;             // vZ
end;

procedure Tplate.returnbtnClick(Sender: TObject);
begin
  Inputdata;            {͑I}
end;

procedure Tplate.tawabtnClick(Sender: TObject);
begin
  tawamidisp;           // ׏d͕\
end;

procedure Tplate.Button1Click(Sender: TObject);
begin
  if graff and 1 = 0 then
    begin
      graff := graff or 1;
      tauegra;
    end
    else
    begin
      graff := graff and ($FF - 3);
      Inputdata;        {͑I}
    end;
end;

procedure Tplate.Button2Click(Sender: TObject);
begin
  if graff and 2 = 0 then
    begin
      graff := graff or 2;
      Ouryoky;
    end
    else
    begin
      graff := graff and ($FF - 3);
      Inputdata;          {͑I}
    end;
end;

procedure Tplate.printbtnClick(Sender: TObject);
begin
  printout;
end;

procedure Tplate.fatigueClick(Sender: TObject);
begin
  tucareSENZU;            {x}ol}
end;

procedure Tplate.bendingClick(Sender: TObject);
begin
  typef := 2;             // 1 ׏dwvZ@Q@ݎwvZ
  Inputdata;              {͑I}
  top := (screen.Height - plate.Height) div 2;
  Left := (screen.Width - plate.Width) div 2;
end;

procedure Tplate.loadingClick(Sender: TObject);
begin
  typef := 1;             // 1 ׏dwvZ@Q@ݎwvZ
  Inputdata;              {͑I}
  top := (screen.Height - plate.Height) div 2;
  Left := (screen.Width - plate.Width) div 2;
end;

procedure Tplate.typeretClick(Sender: TObject);
begin
  typeinput;              // vZ@̎w@׏dw肩ݎw肩
end;

procedure Tplate.bendClick(Sender: TObject);
begin
  zindisp;                // ݓ͕\
end;

procedure Tplate.strengthClick(Sender: TObject);
begin
  straininp;              // ݉׏dgp͈͓͉
end;

procedure Tplate.DatainbKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then if Dataf <> 11 then Inputdata{͑I}
                                   else CtextOut; //  vZ
  if key <> #13 then exit;    // Enter ȂI
  case Dataf of
    1:matinput;           {ގԍ͏}
    2:thicknessinput;     // ͏
    3:Bininput;           // ol͏
    4:B1ininput;          // ol[͏
    5:Lininput;           // ol[̒͏
    6:enginput;           // O͏
    7:L1ininput;          // ׏d_̒͏
    8:Pininput;           // ׏d͏
    9:tawaminput;         // ݈ʒu͏
    10:Zininput;          // ݑ傫͏
    11:strainindata;      // ݉׏dgp͈͓͏
  end;
  Key := #0;
end;

procedure Tplate.comeClick(Sender: TObject);
begin
  if comf = 1 then
    begin
      comf := 0;
      Buttonoff;
      come.Visible := true;
      OKBtn.Visible := False;
      Datain.Visible := False;
      Datainb.Visible := False;
      printbtn.Visible := False;
      calcbtn.Visible := False;
      returnbtn.Visible := False;
      loading.Visible := False;
      bending.Visible := False;
      strength.Visible := False;
      button1.Visible := False;
      button2.Visible := False;

      come.top := 20;
      come.left := 550;
      come.Height := 25;
      come.width := 50;
      come.Font.Height := 15;
      come.Caption := '߂';
      comment;          // ͒
    end
    else
    begin
      comf := 1;
      button1.Visible := true;
      button2.Visible := true;
      Inputdata;        {͑I}
    end;
end;

initialization
  b1in := -1;         // ol[
  Pin := -1;          // ׏d
  timerf := 1;        // Nʕ\
  zin := -1000;       // ݓ͒l
  xin := -1;          // ݌vZ_
  ptina := -1000;     // ׏dwvZp͒l
  ptinb := -1000;     // ׏dwvZp͒l
  ttina := -1000;     // ݎwvZp͒l
  ttinb := -1000;     // ݎwvZp͒l
  comf := 1;
end.

